# Copyright (c) 2004 - 2007 by Jens Wilke 
# This script is released under the GPL license.  Please
# see the included LICENSE file for details.

use strict;
use open ':utf8';
my @all;
# use vars qw( );
# require "/usr/local/lib/gtkgallery/lang";
# my $lang = substr($ENV{LANG}, 0, 2);
# if (-e "/usr/local/lib/gtkgallery/lang.$lang") {require "/usr/local/lib/gtkgallery/lang.$lang"; print "open language file: $!\n" if $d}


sub importhtml {
	my($dir, $ndir) = @_;
	
	# $dir is the destination dir without photo/dataroot
	# $ndir is the source dir
	# $path is $dir without first dir but with leading slash
	my $path = $dir;
	_utf8_off($path);
	$path =~ s/\/([^\/]+)//;
	_utf8_on($path);
	if($d){print "starting importhtml\n\$ndir: <$ndir> \$dir: <$dir> \$path: <$path>\n"}
	my $err;
	
	if ($d){print "\nchecking datadir $dataroot/$dir\n"}
	if(-e "$dataroot/$dir"){
		if (! -d "$dataroot$dir"){$err ="$dataroot$dir does exist but is not a directory\n"}
		if(! -W "$dataroot$dir"){$err = "$dataroot$dir is not writable\n"}
	}else{
		if(! mkdir("$dataroot/$dir")){$err .= "unable to create $dataroot/$dir: $!\n"}
	}
	if($d){print "<cp -r $ndir/data/\* $dataroot/$dir>\n"}
	`cp -r $ndir/data/* $dataroot/$dir`;
	
	if ($d){print "\nchecking photodir $photoroot/$dir\n"}
	if(-e "$photoroot/$dir"){
		if (! -d "$photoroot$dir"){$err ="$photoroot$dir does exist but is not a directory\n"}
		if(! -W "$photoroot$dir"){$err = "$photoroot$dir is not writable\n"}
	}else{
		if(! mkdir("$photoroot/$dir")){$err .= "unable to create $photoroot/$dir: $!\n"}
	}
	if($d){print "<cp -r $ndir/photo/\* $photoroot/$dir>\n"}
	`cp -r $ndir/photo/* $photoroot/$dir`;
	
	if($err){print "error on copy: $err\n"}
	return 1;
}


sub exporthtml {

	# exports a directory structure to an other directory
	# and creates html index pages

	# $dir is dir to export
	# $ndir is the targer dir
	# @sel are the sizes to export
	
	my($med_siz, $dir, $ndir, @sel) = @_;
	if($ndir eq '...'){print "INFO Any destination selected\n"; return;}
	if(-e $ndir){
		if(! -d $ndir){print "INFO Destination is NOT a Directory\n"; return;}
		if(! -W $ndir){print "INFO Destination is NOT writable\n"; return;}
	}else{ 
		if(mkdir($ndir, 0755)){
			print "INFO mkdir $ndir ok\n";
		}else{
			print "INFO mkdir $ndir failed: $!\n"; return;
		}
	}
	if(! @sel){print "INFO Any sizes selected\n"; return;}
	print "INFO Start to export $dir to: $ndir\nINFO Sizes: @sel\n";
	print "INFO Split into Parts, this will need some time. Please wait.\n";
	
	my (@files, @dirs, $files, $dirs, $no_fil);
	($files, $dirs, $no_fil) = exp_list($med_siz, $dir, @sel);
	@files = @$files;
	@dirs = @$dirs;
	print "INFO Calculated amount of Parts: " . ($#files + 1) . "\n";
	print ">> exporthtml \@files: <@files>, \@dirs: <@dirs>\n";
	exp_create($dir, $ndir, \@files, \@dirs, \@sel, $no_fil);
	1;
}

sub exp_create {

	# creates directory structure and copies the files
	#
	# $dir is dir to export
	# $ndir is the targer dir
	# @files and @dirs are 2-dimensional arrays with
	# dir and file list for each part

	my($dir, $ndir, $files, $dirs, $sel, $no_fil) = @_;
	my @files = @$files;
	my @dirs = @$dirs;
	my @sel = @$sel;
	my (@tmp, $p, $tmp_dir, $path2, $path3, @path);
	my $f = 0; # filecounter
	print ">>> exp_create dir: <$dir>, ndir: <$ndir> \@files: <@files> \@dirs: <@dirs>\nNumber of parts: <$#files>\n" if $d;


	
	# create a main overview index for all parts
	#use open ':locale';
	open(MAIN, ">$ndir/index.html");
	print MAIN '<html><head><meta http-equiv="content-type" content="text/html"><title>Album: '.$dir.'</title></head><body><h2>'.$dir.'</h2>'."\n";
	for($p=1; $p <= ($#dirs + 1); $p++){
		print "INFO Start to export Part $p\n";
		print MAIN '<h3><a href="part'.$p.'/html/index.html">Part '.$p.'</a></h3>'."\n";
		@tmp = @{@dirs[($p - 1)]};
		unshift(@tmp, "$dir");
		print "\@tmp is: <@tmp>\n\$tmp[0]: <$tmp[0]>\n" if $d;
		foreach my $tmp_dir (@tmp){
# 			$tmp_dir =~ s/$dir//g;
			$tmp_dir =~ s/\\ / /g;
# 			_utf8_off($tmp_dir);
			print MAIN '<a href="part'.$p.'/html'.$tmp_dir.'/index.html">'.$tmp_dir.'</a><br>'."\n";
		}
	}
	close(MAIN);
	
	# create the parts
	for($p=1; $p <= ($#dirs + 1); $p++){
		@tmp = @{@dirs[($p - 1)]};
		
		# create root dirs in path
		if(! exp_cdir($ndir, $p, '')){
			print  "INFO unable to create root dirs of part $p\! Giving up!\n "; return 1;
		}		
		# create an index for this part
		if(open(INDEX, ">$ndir/part$p/html/index.html")){
			print  "INFO Create $ndir"."part$p/html/index.html\n";
		}else{
			print  "INFO ERROR on create $ndir"."part$p/html/index.html\n0\n";
			return 0;
		}
		print INDEX '<html><head><meta http-equiv="content-type" content="text/html; charset=UTF-8"><title>Album: '.$dir.'</title></head><body link="black"><h2>'.$dir.'</h2>'."\nPart $p \/ " . ($#dirs + 1);# ."\n";
		print INDEX '<br><a href="../../index.html"><font size = -2>Part overview</font></a><br><br>'."\n";
		@tmp = @{@dirs[($p - 1)]};
		#@tmp = sort(@tmp);
		unshift(@tmp, "$dir");
		print "part $p create index: \@tmp is: <@tmp>\n\$tmp[0]: <$tmp[0]>\n" if $d;
		my @tmp2 = @tmp;
		foreach $tmp_dir (@tmp){
# 			$tmp_dir =~ s/$dir//g;
			$tmp_dir =~ s/\\ / /g;
			#$tmp_dir =~ s/^\/(.)+//g;
			_utf8_on($tmp_dir);
			print INDEX '<a href=".'.$tmp_dir.'/index.html">'.$tmp_dir.'</a><br>'."\n";
		}
		print INDEX '<table border="0" cellspacing="20"><tr>'."\n";
		close(INDEX);
		@tmp = @tmp2;
		# go through each dir in part and create index
		foreach $tmp_dir (@tmp){
			#$tmp_dir =~ s/$dir//g;
			#$tmp_dir =~ s/ /\\ /g; # don't use!!!

			# tmp_dir ist jetzt das Unterverzeichnis vom zu exportierenden.
			# was tun, wenn es ein Pfad mit mehreren Verzeichnissen ist?
			# Ist eigentlich egal, da nur dirs, die hier auftauchen Files enthalten, also einfach mit mkpath 
			# in ndir erstellen.
			#exp_cdir($ndir, $p, $tmp_dir);
			print ">>>>>> going to create $tmp_dir in part $d\n" if $d;
			if(exp_cdir($ndir, $p, $tmp_dir)){
				print  "INFO Created dir $tmp_dir for part $p\.\n";
			}else{
				print  "INFO unable to create dir $tmp_dir for part $p\! Giving up!\n0\n"; 
				return 0;
			}
			
			# create an index for this tmp_dir
			# this will be overwritten, if it contains files, otherwise it won't
			
			my $uppath = $tmp_dir;
			_utf8_off($uppath);
			$uppath =~ s/\/([^\/]+)/\.\.\//g;
			if($d){print"uppath is: <$uppath>\n"}
			my $up = '../../';
			if($uppath){$up = '../'};
			if($tmp_dir){
				if(open(INDEX, ">$ndir/part$p/html/$tmp_dir/index.html")){
					print  "INFO Created file $ndir"."part$p/html/$tmp_dir/index.html\n";
				}else{
					print  "INFO ERROR on create file $ndir"."part$p/html/$tmp_dir/index.html: $!\n"; 
					return 0;
				}
				print INDEX '<html><head><meta http-equiv="content-type" content="text/html; charset=UTF-8"><title>Album: '.$dir.'</title>  <meta http-equiv="content-type" content="text/html"></head><body link="black"><h3>'.$tmp_dir.'</h3>';
				print INDEX '<b>Part '.$p.'</b><br><a href="'.$uppath.'index.html">up</a><br>'."\n";
				print INDEX '<table border="0" cellspacing="20"><tr>'."\n";
				close(INDEX);
			}
		}
		# go through the @files
		@tmp = ();# undef;
		# if (defined(@files)){
		my $f = 0;
		if(@files){
		        @tmp = @{@files[($p - 1)]};
		}else{print "INFO Any files to export\n"; return}
		#@tmp = sort(@tmp);
		print "all files in part are: <@tmp>\n" if $d;
		my $u = $p-1;
		if($d){open(OUT, ">/tmp/out.$u.files"); print OUT "@tmp"; close(OUT)}
		my($path, $opath);
		my $a =1;
		foreach my $file (@tmp){
			# file in path und file zerlegen
			# a hochzhlen, wenn path sich ndert, oder a=5, a zurcksetzen
			if(! -f "$photoroot$file"){ next;}
			$f++;
			_utf8_off($file);
			print  "INFO > Export file $f/$no_fil: $file \n";
			$path = $file;
			$path =~ s/\/([^\/]+)$//g;
			$path =~ s/\\ / /g;
			$file =~ s/\\ / /g;
			my $tfile = $file;
			$tfile =~ s/(.+)\///g;
			my $tfile2 = $tfile;
			_utf8_on($tfile2);
			_utf8_on($tfile);
			_utf8_on($file);
			#$path =~ s/$dir//g;
			if($opath ne $path){$a =1}
			$opath = $path;
			my $uppath = $path;
			$uppath =~ s/\/([^\/]+)/\.\.\//g;
			if($d){print"uppath is: <$uppath>\n"}
			
			#print "copy file <$file>, tfile: <$tfile>  in path <$path>\n" if $d;
			_utf8_on($path);
			my $index = "$ndir/part$p/html/$path/index.html";
			print ">>>> OPEN INDEX $index\n" if $d;
			open(INDEX, ">>$index") || print "INFO >>>>>>>>$index: $!\n";
			print INDEX '<td valign="top"><table border = "0"><tr><td valign="top">';
			print INDEX $tfile . '</td></tr><tr><td valign = "bottom">';
			print "sizes are: <@sel>\n" if $d;
			my $chkpath= "$ndir/part$p/data$path";
			print " \$chkpath: <$chkpath>\n" if $d;
			$chkpath =~ s/(\/)+/\//g;
			$chkpath =~ s/^\///;
			print "\@path: <@path>\n" if $d;
			@path = ();
			@path = split(/\//, $chkpath);
			print ">>>>>>>>>>  checking for \$chkpath: <$chkpath>\n" if $d;
			#_utf8_off($chkpath);
			$path2 = "";
			if(! -e "$chkpath"){
					print "doesn't exist\n" if $d; 
					#$path =~ s/(\/)+/\//g;
					foreach $path3 (@path){
						print "dir is $path3\n" if $d;
						$path2 = "$path2/$path3";
						$path2 =~ s/(\/)+/\//g;
						print "checking for $path2\n" if $d;
						if(! -e "$path2"){
							print "creating $path2\n" if $d;
							if(! mkdir("$path2")){
								print "INFO ERROR: $path2 $!\n";
							}else{
								print "INFO $path2 created\n";
							};
						}
					}
# 			if(mkpath("$chkpath")){
# 					print "... created\n" if $d;
# 					print  "INFO $chkpath created\n";
# 				}else{
# 					print  "INFO ERROR unable to create $chkpath\!\n0\n"; return 0;
# 				}
			}else{
				print "... exists\n" if $d
			}
			for(my $j = 0; $j <= $#sel; $j++){
				#if ($sel[$j] == 640){print "omit size 640\n"; next;}
				if ($d){
					print "size: <$sel[$j]>\nchecking for path <$ndir/part$p/data/$path/$sel[$j]> ... ";
					if(! -e "$ndir/part$p/data/$path/$sel[$j]"){
						print "doesn't exist ...";
					}else{
						print "exists ...";
					}
					print "\n";
				}
				print "going to check $ndir/part$p/data/$path/$sel[$j] AND size ne full\n" if $d;
				if((! -e "$ndir/part$p/data/$path/$sel[$j]") && ($sel[$j] ne 'full')){
					print "doesn't exist and is not full size\n" if $d;
					_utf8_on($ndir); _utf8_on($path); _utf8_on($sel[$j]);
					print "INFO mkdir $ndir/part$p/data/$path/$sel[$j]\n";
					if(mkdir("$ndir/part$p/data/$path/$sel[$j]")){
						print "INFO Dir $ndir/part$p/data/$path/$sel[$j] created\n"
					}else{
						print "INFO ERROR: $!\n";
					}
				}elsif($sel[$j] eq 'full'){
					print "size full doesn't need a subdir\n"
				}else{
				
					print "exists\n";
				}
				
				if($sel[$j] eq 'thumbnails'){
					my $source = "$dataroot/$path/$sel[$j]/$tfile";
					print "copy thumb $source\n" if $d;
					if(-e "$source"){
						print "exists\n" if $d;
						print INDEX '<br><a href="'.$uppath.'../photo'."$path/$tfile".'"><IMG src="'.$uppath.'../data'."$path/thumbnails/$tfile".'" align="left" alt="'.$tfile.'"></a><br><br></td></tr><tr><td> ';
						#print "copy $dataroot/$dir$path/$sel[$j]/$tfile to $ndir\/part$p\/data$path/$sel[$j]\n" if $d;
						#mkpath("$ndir\/part$p\/data/$path\/thumbnails");
			 			if(copy("$source", "$ndir/part$p/data$path/$sel[$j]/$tfile2")){
							print  "INFO Thumbnail copied\n";
						}else{
							 #print "$!\n";
							 print  "INFO Thumbnail not copied: $!\n";
						}
					}else{
						# hack: copy main file, if thumbnail not available
						# for non-images and non latin1 7bit
						print "INFO copy full size instead of thumb.\n";
						copy("$photoroot$file", "$ndir/part$p/photo$path") || print "$!\n";
						print INDEX '<br><a href="'.$uppath.'../photo'."$path/$tfile".'">view</a><br></td></tr><tr><td>';
					}
				}elsif($sel[$j] eq 'full'){
					print "going to copy full: <$photoroot$file> to <$ndir/part$p/photo$path/$tfile2>\n" if $d;
					if(copy("$photoroot$file", "$ndir/part$p/photo$path/$tfile2")){
						print INDEX '<a href="'.$uppath.'../photo'."$path/$tfile".'">'.$l_ful.'</a> ';
						print  "INFO Full size copied.\n";
					}else{
						print  "INFO ERROR on copy full size $file: $!\n";
					}
				}elsif($sel[$j] eq 'descriptions'){
					#print "checking for desc: <$dataroot/$dir$path/descriptions/$tfile\.txt>\n";
					print ">>>>>>>>>>> checking descriptions\n" if $d;
					if(-e "$dataroot/$path/descriptions/$tfile.txt" ){
						if(copy("$dataroot/$path/descriptions/$tfile.txt", "$ndir/part$p/data$path/descriptions/$tfile2.txt")){
							open(DESC, "< $dataroot/$path/descriptions/$tfile\.txt");
							my @desc = <DESC>;
							close(DESC);
							_utf8_on($desc[0]);
							print INDEX ' <br><a href="'.$uppath.'../data'.$path.'/descriptions/'."$tfile".'.txt">'.$desc[0].'</a> ';
							print  "INFO Description copied.\n";
						}else{
							print "error on copy description  $dataroot/$path/descriptions/$tfile.txt: $!\n" if $d;
						}
					}else{
						print "INFO $dataroot/$path/descriptions/$tfile2.txt Any description found.\n";
					}
				}else{
					print "checking size $sel[$j]\n" if $d;
					if(-e "$dataroot/$path/$sel[$j]/$tfile"){
 						if(copy("$dataroot/$path/$sel[$j]/$tfile", "$ndir/part$p/data$path/$sel[$j]/$tfile2")){
							print INDEX '<a href="'.$uppath.'../data'."$path/$sel[$j]/$tfile".'">'.$sel[$j].'</a> ';
							print  "INFO Size $sel[$j] copied.\n";
						}else{
							print "ERROR on copy: $!\n" if $d;
						}
					}else{
						print "doesn't exist\n" if $d;
					}
				}
				print "size: <$sel[$j]> finished\n" if $d;
			} # end for sizes 
			print INDEX '</td></tr></table></td>'."\n";
			if($a == 5){$a = 0; print INDEX '</tr>'."\n".'<tr>'}
			$a++
		}
		print "FINISHED with files\n" if $d;
		# finish all index files in the dirs
		#@tmp = @{@dirs[($p - 1)]};
		foreach $tmp_dir (@tmp2){
			$tmp_dir =~ s/^$dir//g;
			$tmp_dir =~ s/\\ /\ /g;

			print "finishing $ndir/part$p/html/$tmp_dir/index.htm\n" if $d;
			if(open(INDEX, ">>$ndir/part$p/html/$tmp_dir/index.html")){
				 print "opened\n";
			}else{
				print "INFO ERROR on write $ndir/part$p/html/$tmp_dir/index.html: $!\n";
			}
			if(! print INDEX '</tr></table></body></html>'){
				print "INFO ERROR on write $ndir/part$p/html/$tmp_dir/index.html $!\n"
			}
			if(close(INDEX)){
				print "closed\n";
			}else{
				print "$!\n";
			}
		}
		print "INFO Part $p finished\n" if $d;
	}
	print  "INFO Export done.\n";
1;
}

sub exp_cdir {
	
	# create dirs in $path
	
	my($ndir, $p, $path) = @_;
	my ($path2, @path);
	print "INFO Check for $ndir/part$p/\*$path\n";
	print "going to create dir in <$ndir> for part <$p>\n" if $d;
	if(! -e "$ndir/part$p/"){
		if(! mkdir("$ndir/part$p")){print "INFO ERROR: part $!\n"; return 0};
	}
	$path =~ s/(\/)+/\//g;
	$path =~ s/^\///i;
	@path = split(/\//, $path);
	unshift(@path, ''); # to create photo, data and html subdirs at first
	foreach $path (@path){
		$path2 = "$path2/$path";
		$path2 =~ s/(\/)+/\//g;
		print "creating dir for $path2\n";
		if(! -e "$ndir/part$p/photo/$path2"){
			if(! mkdir("$ndir/part$p/photo/$path2")){print "INFO ERROR: photo $!\n"; return 0};
		}
		if(! -e "$ndir/part$p/data/$path2"){
			if(! mkdir("$ndir/part$p/data/$path2")){print "INFO ERROR data $!\n"; return 0};
		}
		if(! -e "$ndir/part$p/html/$path2"){
			if(! mkdir("$ndir/part$p/html/$path2")){print "INFO ERROR: $!\n"; return 0};
		}
	}
# 	my $path2 = $path; 
# 	_utf8_on($path2);
# # 	_utf8_on($path2);
#	my $path2 = $path;
# 
# 	if(! -e "$ndir/part$p/photo/$path"){
# 		if(! mkpath("$ndir/part$p/photo/$path")){print "INFO ERROR: photo $!\n"; return 0};
# 	}
# 	if(! -e "$ndir\/part$p\/data/$path"){
# 		if(! mkpath("$ndir/part$p/data/$path2")){print "INFO ERROR data $!\n"; return 0};
# 	}
# 	if(! -e "$ndir/part$p/html/$path"){
# 		if(! mkpath("$ndir/part$p/html/$path2")){print "INFO ERROR: $!\n"; return 0};
# 	}
	return 1;
}

sub exp_list {

	# creates file and directory list
	#
	# $dir is the dir to export
	# @sel are the selected sizes to export
	#
	# returns two-dimensional arrays
	# @files and @dirs
	# second dimension is the part number
	# each part has at the most $partsize

	my ($med_siz, $dir, @sel) = @_;
	my (@files, @dirs, @tmp, @tmp_dirs, $no_fil);
	#@dirs = ('');
	use File::Find;
	my $part = 0;
	my $filesize = 0;
	my $partsize = 0;
	my $maxpartsize = 680000; # 700 MB CD
	if($med_siz eq "DV"){$maxpartsize = 4350000}; # 4,7 GB DVD
	if($med_siz eq "DL"){$maxpartsize = 8250000}; # 8,5 GB DL-DVD
	print "find files in <$photoroot$dir>\n" if $d;
	finddepth{ wanted => \&exp_find, follow => 1}, "$photoroot$dir";
	#@all = glob("$photoroot$dir"."/*");
	#@all = `glob -r $photoroot$dir`;
	@all = sort(@all);
	print "\@all is <@all>\n" if $d;
	#if($d){open(OUT, ">/tmp/out.all"); print OUT "@all"; close(OUT)}
	print "INFO \ \n"; # Dummy line to be removed by the first PROINFO 
	my $ofile; # to wreak files, found 1+
	foreach my $file (@all){
		chomp($file);
		if($file eq $ofile) {next;}
		$ofile = $file;
		_utf8_on($file);
		#my $tfile = $_;

		#$file =~ s/ /\\ /g; # beltter!
		#print "INFO Checking: $file\n";
		$file =~ s/$photoroot//g;
		print "checking <$photoroot/$file>: " if $d;
		if (-d "$photoroot/$file") {
			#print "INFO Dir: $file\n";

			print "dir\n" if $d;
			$file =~ s/\/\//\//g;
			push(@tmp_dirs, $file);
			$partsize += 4;
		}elsif (-f "$photoroot/$file") {
            		print "file\n" if $d;
			my $path = $file;
			my $tfile = $file;
			_utf8_off($path);
			_utf8_off($tfile);
			$path =~ s/\/([^\/]+)$//g;
			$tfile =~ s/(.)+\///g;
			if(@files){
				@tmp = @{$files[$part]}
			}else{
				@tmp = ()
			}
			#$no_fil = $#tmp;
 			$no_fil++;
# 			$no_fil++;
			print "PROINFO Number of Files: $no_fil\n";
			print ">> no_fil is <$no_fil>\n" if $d;


			#my $tmp = `du -cs $photoroot$file $dataroot/$path\/\*/$tfile\*`;
			#print "\$tmp: <$tmp>\n" if $d;
			$filesize = 0;
			my $tmpsize;
			_utf8_on($path);
			_utf8_on($tfile);
			foreach my $size (@sel){
				print "calculate size $size: " if $d;
				if($size eq 'full'){
					$tmpsize = `du $photoroot"$file" |cut -f 1`;
				}else{
					$tmpsize = `du $dataroot/"$path"/$size/"$tfile"\* |cut -f 1 > /dev/null`;
				}
				print "$tmpsize" if $d;
				chomp($tmpsize);
				if($tmpsize){$filesize += $tmpsize}
			}
			print "filesize: <$filesize>\n" if $d;
			if($partsize + $filesize > $maxpartsize){
				my $tpart = $part + 2;
				$partsize = $partsize / 1024;
				print "INFO  \nINFO Part $tpart calculated: $partsize MB.\n";
#				print "INFO \ \n"; # Dummy line to be removed by PROINFO 
				$part++;
				$no_fil = 0;
				$partsize = $filesize;
				push(@dirs, [ @tmp_dirs ]);
				@tmp_dirs = ();
				# if inside of a dir, a new part begins, this dir is missing in @dirs[new_part]
				push(@tmp_dirs, $path);
			}else{
				$partsize += $filesize;
			}
			$files[$part][$no_fil] = $file;
        	} else {
			print "neither file nor dir\n" if $d;
		}
    	}
	$partsize = $partsize / 1024 if $partsize;
	print "INFO \ Part $part calculated: $partsize MB.\n"; # again for the last  part
	print "INFO \ \n"; # Dummy line to be removed by PROINFO 
	print "push \@tmp_dirs @tmp_dirs to \@dirs\n" if $d;
	push(@dirs, [ @tmp_dirs ]);
	#print "INFO Dirs: <@dirs>\n";
	#print "INFO tmp_dirs: <@tmp_dirs>\n";
	return(\@files, \@dirs, $no_fil);
}

sub exp_find { 
		my $file = $_;
		_utf8_on($file);
		print "file is $file\n" if $d;
		if($file ne '.' && $file ne '..'){
			#$file =~ s/$photoroot//g;
			my $path = $File::Find::dir;
			print "path is $path\n" if $d;
			#if(! $path =~ /\.xvpics/i){
			$path =~ s/$photoroot//g;
			$file = "$path/$file";
			push(@all, $file);
			if(-d "$photoroot/$file"){
				find{ wanted => \&exp_find, follow => 1}, "$photoroot$file";
			}
			#}
		}
}

sub exp_list_o {

	# creates file and directory list
	#
	# $dir is the dir to export
	# @sel are the selected sizes to export
	#
	# returns two-dimensional arrays
	# @files and @dirs
	# second dimension is the part number
	# each part has at the most $partsize

	my ($dir, @sel) = @_;
	my (@files, @dirs, @tmp, @tmp_dirs);
	#@dirs = ('');
	use File::Find;
	my ($part, $filesize, $partsize);
	my $maxpartsize = 715000;
	print "find files in <$photoroot$dir>\n" if $d;
	find( sub {
		my $tfile = $_;
		my $path = $File::Find::dir;
		$path =~ s/$photoroot//g;
		$path =~ s/ /\\ /g;
		$tfile =~ s/ /\\ /g;
		my $file = "$path/$tfile";
		if (-d $_) {
			print "Dir: $File::Find::name\n";
			$path = $File::Find::name;
			$path =~ s/$photoroot//g;
			$path =~ s/ /\\ /g;
			push(@tmp_dirs, $path);
			$partsize += 4;
		}
        	if (-f $_) {
            		print "$File::Find::name\n";
			if(@files){
				@tmp = @{$files[$part]}
			}else{
				@tmp = ()
			}
			my $no_fil = $#tmp;
			$no_fil++;
			print ">> no_fil is <$no_fil>\n" if $d;


			my $tmp = `du -cs $photoroot$file $dataroot/$path/\*/$tfile\*`;
			print "\$tmp: <$tmp>\n" if $d;
			$filesize = 0;
			my $tmpsize;
			foreach my $size (@sel){
				if($size eq 'full'){
					$tmpsize = `du $photoroot$file |cut -f 1`;
				}else{
					$tmpsize = `du $dataroot/$path/$size/$tfile\* |cut -f 1 `;
				}
				chomp($tmpsize);
				$filesize += $tmpsize;
			}
			print "filesize: <$filesize>\n" if $d;
			if($partsize + $filesize > $maxpartsize){
				$part++;
				$no_fil = 0;
				$partsize = $filesize;
				push(@dirs, [ @tmp_dirs ]);
				@tmp_dirs = ();
				# if inside of a dir, a new part begins, this dir is missing in @dirs[new_part]
				push(@tmp_dirs, $path);
			}else{
				$partsize += $filesize;
			}
			$files[$part][$no_fil] = $file;
        	}
    	}, "$photoroot$dir"); 
	print "push \@tmp_dirs @tmp_dirs to \@dirs\n" if $d;
	push(@dirs, [ @tmp_dirs ]);
	return(\@files, \@dirs);
}

sub exp_pipe {
	#my ($fh, $id, $tmp) = @_;
	#print "exp_pipe: @_\n" if $d;
# 	my $tmp = $_[2];
# 	my @tmp = @$tmp;
	my ( $buffer, $obutton, $cbutton, $fh, $id ) = @_;
	#print "exp_pipe: ( $buffer, $obutton, $cbutton, $fh, $id )\n" if $d;
# 	my ($b, $e, $tmp) = @_;
# 	my @tmp = @$tmp;
# 	my $buffer  = $tmp[0];
# 	my $obutton = $tmp[1];
# 	my $cbutton = $tmp[2];

      if ( eof($fh) ) {
        Gtk2::Helper->remove_watch ($id)
	    or die "couldn't remove watcher\n";
	close($fh);
	$obutton->set_sensitive (1);
	$obutton->grab_focus;
	$cbutton->set_sensitive (0);
	return 1;
      }
	my $line = <$fh>;
#	my $line = <EXPORT>;
	chomp($line);
	#print "Buffer: <$buffer>\n" if $d;
	print "Parent Pid $$ just read this: `$line'\n" if $d;
	my $text = $buffer->get_text($buffer->get_start_iter, $buffer->get_end_iter, 1);
	chomp($text);
	my $search = 'INFO ';
	Gtk2->main_iteration while Gtk2->events_pending;
	if($line =~ s/^$search//g){
		#$buffer->set_text("$text\n$line");
		$buffer->insert ($buffer->get_end_iter, "$line\n" );
	#	Gtk2->main_iteration while Gtk2->events_pending;
	}
	$search = 'PROINFO ';
	if($line =~ s/^$search//g){
		$text =~ s/(\n[^\n]+)$//g;
		$buffer->set_text("$text\n$line");
	}
	
  	#if(($line eq "Export done.")|| ($line eq '0')){
		
#    		print "close the child and return\n" if $d;
#       		close(EXPORT); 
# 		$obutton->set_sensitive (1);
# 		$obutton->grab_focus;
# 		$cbutton->set_sensitive (0);
# 		return 0; # return false to uninstall add_watch
#   	}
	1;
}

1;
