##############################################################################
# Image Magic subroutines                                                   ##
#                                                                           ##
# by Michael Spiceland (do not copy without permission)                     ##
# Copyright (C) 2004 - 2007 by Jens Wilke jens at wilke dot org
#
##############################################################################

use Image::Magick;
# use Encode qw(is_utf8 _utf8_on _utf8_off encode decode); 

sub convert{
	my $imageToConvert =  $_[0];
	use Image::Xpm;
	`jpegtopnm $imageToConvert | ppmtoxpm > /tmp/tmp.xpm`;
        #my $j = Image::Xpm->new();
	my $i = Image::Xpm->new(-file => '/tmp/tmp.xpm');
	#$j->load(-file, '/tmp/tmp.xpm');
	my %i = %{$i};
	my @keys = sort keys (%i);
	print "@keys\n\n";
	print $i{'-pixels'};
	#return(@newxpm);
# 	my $format = $_[1];
# 	my $image = Image::Magick->new;
# 	$image->Read("$imageToConvert");
# 	my @blob = $image->ImageToBlob();
# 	$newimage=Image::Magick->new(magick=>"$format");
#   	$newimage->BlobToImage(@blob);
# 	return($newimage);
	#$newimage->convert(xpm);
}

##############################################################################
# Resize an image to have a maximum of the given width.  If the width is
# less than what is given, it stays the same.
#
# $_[0] = full path to input image
# $_[1] = full path to output image 
# $_[2] = max width to allow pictures to be
##############################################################################

sub resize($$$){
	my ($img, $thb) = @_;
	my $return;
	my($imageToScale) = Image::Magick->new;
	#_utf8_off($img);
	#_utf8_off($thb);
	my($itemToDisplay) = "$img";

	#$return .= "imtemToDisplay=$itemToDisplay\n";

	if(chckmime($itemToDisplay)){
		#_utf8_off($itemToDisplay);
		print "reading $photoroot/$itemToDisplay\n" if $d;
		my($x) = $imageToScale->Read("$photoroot/$itemToDisplay");
		warn "$x" if "$x" && $d;
		my($xSize, $ySize) = $imageToScale->Get('width', 'height');
		#$return .= "xSize=$xSize\nySize=$ySize\n";
		my $scaleFactor;
		my ($new_width,$new_height);

		if(($xSize > $ySize) && ($_[2] != 2494)){
			$scaleFactor = $xSize/$_[2];
			if($xSize > $_[2]){
				$new_width = $_[2];
				$new_height = $ySize/$scaleFactor;
			}
		}else{
			$scaleFactor = $ySize/$_[2];
			if($ySize > $_[2]){
				$new_height =$_[2];
				$new_width = $xSize/$scaleFactor;
			}
		}

	#return .= "\n$xSize x $ySize => $new_width x $new_height\n";
	# only resize, if images don't grow! Otherwise write them unchanged
		if($scaleFactor > 1){
			$x = $imageToScale->Scale(width=>$new_width,height=>$new_height);
			$x = $imageToScale->Set(quality=>90); 
		}

		warn "$x\n" if "$x" && $d;
		$x = $imageToScale->Write("$dataroot/$thb");
		#$return .= "imageToScale=$_[1]\n";
		warn "ERROR $x\n" if "$x" && $d;
	}
	undef $imageToScale;
	# Gtk2 -> main_iteration() while (Gtk2 -> events_pending());
	return $return;
}

##############################################################################
# Rotate an image with the given number of degrees
#
# $_[0] = full path to input image
# $_[1] = degrees of rotation
##############################################################################
sub rotate($$$){
	my $return;
	my $status;
	my $album = $_[0];
	my $file = $_[1];
	my $degree = $_[2];
	my $image = "$photoroot/$album/$file";
	#$image =~ s/ /\\ /gi;
	$image =~s/\/\//\//gi;
	#my $rimage = '"'.$image.'"';

	#$image = '"'.$image.'"';
	##_utf8_on($rimage);
	my $rimage = $image;
# 	$rimage = encode($enc, $image);
	print "rotate $rimage \n" if $d;
 	if(chckmime("$album/$file")){
#if(1){
		# remove exif rotation tag, because jpegtran doesn't touch it.
		chomp( my $jhead = `which jhead`);
		`$jhead -norot $rimage`;
		chomp( my $jpegtran = `which jpegtran`);
# 		if(open(RDFIL, "<$rimage")){
# 			my @jpg = <RDFIL>;
# 			close(RDFIL);
# 			open(JPGTRN, "| $jpegtran");
# 			print JPGTRN "-copy all -rotate $degree -outfile $rimage.tmp\n";
# 			print JPGTRN "@jpg\n";
# 			close(JPGTRN);
# 		}else{
# 			print "$!\n";
# 		}
		if($jpegtran){
			`"$jpegtran" -copy all -rotate $degree -outfile "$rimage.tmp" "$rimage"`;
# 			_utf8_on($rimage);
	  		move("$rimage\.tmp", "$rimage") || print "$!\n";
	  		#$suc = 1
		}else {
	  		print "... with imagemagick\n" if $d;
			$rimage =~ s/\\//gi;
			#$rimage =~ s/ /\\ /gi;
			if(-e "$rimage"){	
		  		my $status;
		  		my $img = Image::Magick->new;
		  		$status = $img->Read("$rimage");
		  		print "read: $status\n" if $status && $d;
		  		$img->Rotate(degrees=>$degree);
		  		$status = $img->Write("$rimage");
		  		print "write: $status\n" if $status && $d;
			}else{
				print "file $rimage doesn't exist: $!\n" if $d
			}
			#undef $rimage;
		}
		print "rotated\n" if $d;
		# regenerate exif thumbnail.
		#`$jhead -rgt $rimage`;
		# deletes exif thumbnail.
		`$jhead -dt "$rimage"`

	}
	return $return;
}

##############################################################################
# overlay image with a logo, etc
#
# $_[0] = full path to input image
# $_[1] = full path to output image
# $_[2] = full path to watermark to put on top of image
##############################################################################
sub overlay($$$){
	my($imageToScale) = Image::Magick->new;
	my($itemToDisplay) = "$_[0]";
	my($x) = $imageToScale->Read($itemToDisplay); # read in the picture
	warn "$x" if "$x";
	my $image_overlay = Image::Magick->new();
        $status = $image_overlay->Read("$_[2]");
	$status = $imageToScale->Composite(
        	compose=>Over,
                image=>$image_overlay,
                gravity=>SouthEast
	);
	#print "Error: $status" if "$status";
        undef $image_overlay;
	$x = $imageToScale->Write("$_[1]");
	warn "$x" if "$x";
	undef $imageToScale;
}

return 1;
