# Copyright (C) 2004 - 2007 by Jens Wilke jens at wilke dot org
# This script is released under the GNU GPL license.  Please
# see the included LICENSE file for details.

#
# This library is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2.1 of the License, or (at your option)
# any later version.
#
# This library is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU Library General Public License for
# more details.
#
# You should have received a copy of the GNU Library General Public License
# along with this library; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307  USA.

# we require things from 1.04.
use Gtk2 1.04, -init;
use Gtk2::Gdk::Keysyms;
use Storable; 
use strict;

##########################################################################
package main;

# Copyright (c) 2004 - 2007 by Jens Wilke 

use strict;
use Gtk2 -init;
use Gtk2::SimpleMenu;

use vars qw( $d @print_sizes $l_ord $l_chl $l_odn $l_onr $l_sor $l_fxt $l_fxl $l_err $l_e1 $l_e2 $l_e3 $l_for $l_e_c $l_num $l_ski $l_bor $l_opt $l_ihg $l_nam $l_don $l_e4 $l_e5 $l_e6 $l_e7 $l_e8 $l_e9 $l_e10 $l_ul1 $l_ul2 $l_ul3 $l_ul4 $l_ul5 $f_lb1 $lim1 );

my $combo;
my @sel_pic; # contains multiple selections to order

sub o_source_drag_data_get {
  my ($slist, $context, $data, $info, $time, $pics) = @_;
  my @pictures = @$pics;
  @sel_pic = ();
  if ($d) {print ("o_source_drag_data_get\n\@pictures is @pictures\n\$info is $info\n")};

  if ($info eq 'TARGET_ROOTWIN') {
    if ($d) {print ("I was dropped on the rootwin\n");}
  } else {
  	  my @sel = $slist->get_selected_indices;
	  foreach my $i (@sel){
  	  	my $pic = $pictures[$i];
	  	my @list = split /\n/, $data->data;
          	if ($d) {print "\$data is $data\n";
	  	print "\@list is @list\n";
	  	print "\@sel is @sel\n";
	  	print "\$pic is $pic\n";}
	 	_utf8_off($pic);
	  	if (filetype("$photoroot/$pic") eq "jpeg") {
			push(@sel_pic, $pic);
		}else{
 			print "not a jpeg image\n" if $d;
		};
	  }
	  $data->set ($data->target, 8, 0);
# 	  	my $target_list = Gtk2::TargetList->new('same-app');
# 		my $atom = Gtk2::Gdk::Atom->new("text/uri-list");
# 		$target_list->add($atom, 0, 0);
# 		$slist->drag_dest_set_target_list($target_list);
  }
}

sub o_label_drag_data_received {
  my ($widget, $context, $x, $y, $data, $info, $time, $o_model) = @_;
  print "Data is <$data>\nInfo is <$info>" if $d;
  #if(!$data){$data->{'format'} = 8; $data->{'length'} = 1 }
  if ($data == 1 || (($data->length >= 0) && ($data->format == 8)))
    {
      my @pictures;
      my $tmp;
      print "\@sel_pic is <@sel_pic>\n" if $d;
      if(! @sel_pic){
      		print"called from keystroke\n" if $d;
		 @sel_pic = ($info)
	}
	@pictures = @sel_pic;
	@sel_pic = ();

      if($d){print"\$tmp is <$tmp> \n\@pictures is <@pictures>\n pictures[0] is $pictures[0]\n"}

#     if($pictures[0] eq "0"){return}; # if a non jpeg image was dropped...
      foreach my $pic (@pictures){  
      		$pic =~ s/(\/+)/\//g;
		my $thb1 = $pic;
# 		_utf8_off($pic);
		if ($d) {
			print ("Received $pic in label\n");
			print "\n\$o_model is $o_model\n";
# 			print "\$pic2 is $pic2\n";
		}
 		if (filetype("$photoroot/$pic") ne "jpeg") {
			&dialog_err($l_err, "$photoroot/$pic \n$l_nam");
			return;
		}
      		$thb1 =~ s/\/([^\/]+)$/\/thumbnails\/$1/g;
      		$thb1 = $dataroot.$thb1 ;
		print "thumb is $thb1\n" if $d;
      		#my $pixbuf = Gtk2::Gdk::Pixbuf->new_from_file ($thb1);
		_utf8_on($thb1);
      		my $pixbuf = Gtk2::Gdk::Pixbuf->new_from_file ($thb1);
      #my $iter = $o_model->append();
      # $o_model->set ($iter, 2, $pic);
      #$o_model -> set($o_model -> append(), 3, "test");
       		my $iter = $o_model->append();
# 		$o_model->set($iter, 0 => 1);
		_utf8_on($pic);
 		$o_model->set($iter,
 			0 => 1, # size
 			1 => $pixbuf,
 			2 => $pic,
 			3 => [qw/9x13 10x15 13x18 20x30 30x45 40x60 50x75/],
 			4 => 0,
 			5 => 0,
 			6 => 0,
 			7 => 0,  # border
 			8 => 0
			); # opt

	# add a dummy child, so the row may be expanded.
	# $o_model->append ($iter);

      		if($data != 1){
			$context->finish (1, 0, $time);
		}
	}
		print "o_model iters set\n" if $d;
      		return;
    	}
	if($data != 1){
		  $context->finish (0, 0, $time);
	}
  print "o_label_drag_data_received finished\n" if $d;
}

sub o_create_model {
   # create list store
   print "o_create_model\n" if $d;
   my $o_model = Gtk2::ListStore->new ('Glib::Int',
      					 'Gtk2::Gdk::Pixbuf',
                                          'Glib::String',
 					 'Glib::Scalar',
 					 'Glib::Boolean',
 					 'Glib::String',
 					 'Glib::Double',
 					 'Glib::String',
  					 'Glib::Boolean'
					  );

#     my $iter = $o_model->append (undef);
#    $o_model->set ($iter, 0, '/', 1, '/');

    return $o_model;
}

sub o_create_treeview {

       my ($o_model) = @_;
       print "o_create_treeview\n" if $d;
       # create tree view
       my $o_treeview = Gtk2::TreeView->new_with_model($o_model);
       $o_treeview->set_rules_hint (1);
       $o_treeview->get_selection->set_mode ('single');

       my $o_selection= $o_treeview->get_selection();
       if($d){print "selection mode: " . ($o_selection->get_mode()||"undef") . "\n";
               $o_selection->signal_connect("changed", sub {if ($d){print "selected\n"}});
               if($d){print"calling o_add_columns($o_treeview)\n";}}
       &o_add_columns($o_treeview);

       # expand all rows after the treeview widget has been realized
       # $treeview->signal_connect (realize => sub { $_[0]->expand_all; 1 });

       return $o_treeview;
}

sub o_add_columns {
	# columns for the order table
   my $o_treeview = shift;
   my $o_model = $o_treeview->get_model;
   if($d){print"o_add_columns with treeview $o_treeview, model $o_model\n"}
   my $textrenderer = Gtk2::CellRendererText->new;
   $textrenderer->set (xalign => 0.0);

   my $pixrenderer = Gtk2::CellRendererPixbuf->new;

   my $togrenderer = Gtk2::CellRendererToggle->new;
   # $togrenderer->set (xalign => 0.0);
   $togrenderer->signal_connect(toggled => sub {if ($d){print"toggled\n"};
		my ($cell, $path_str) = @_;
		my $path = Gtk2::TreePath->new ($path_str);
		my $iter = $o_model->get_iter($path);
		my ($index) = $o_model->get ($iter, 8);
		if ($d){print"cell: $cell path: $path index: $index model: $o_model\n"}
		$index = $index -1; $index = $index * $index; # change TRUE <=> FALSE
		$o_model->set ($iter, 8, $index);
   });

   my $croprenderer = Gtk2::CellRendererToggle->new;
   # $croprenderer->set (xalign => 0.0);
   $croprenderer->signal_connect(toggled => sub {if ($d){print"toggled\n"};
		my ($cell, $path_str) = @_;
		my $path = Gtk2::TreePath->new ($path_str);
		my $iter = $o_model->get_iter($path);
		my ($index) = $o_model->get ($iter, 4);
		if ($d){print"cell: $cell path: $path index: $index model: $o_model\n"}
		$index = $index -1; $index = $index * $index; # change TRUE <=> FALSE
		$o_model->set ($iter, 4, $index);
   });
my $listrenderer = Mup::CellRendererPopup->new;
$listrenderer->set (mode => 'editable');

# this handler commits the user's selection to the model.  compare with
# the one for the typical text renderer -- the only difference is a var name.
$listrenderer->signal_connect (edited => sub {
		my ($cell, $text_path, $new_index, $model) = @_;
		if($d){print"got signal for cell $cell text_path $text_path
			new_index $new_index model $model\n"}
		my $path = Gtk2::TreePath->new_from_string($text_path);
		my $iter = $model->get_iter($path);
		$model->set ($iter, 0, $new_index); # store $cell->{index} in column 0
	}, $o_model);

my $numrenderer = Gtk2::CellRendererSpinButton -> new();

$numrenderer -> set(mode => "editable",
                 min => 0,
                 max => 10,
                 step => 1,
                 digits => 0);

$numrenderer -> signal_connect(edited => \&cell_edited, $o_model);
	
   my $col1 = Gtk2::TreeViewColumn->new_with_attributes($l_pic, $pixrenderer, 'pixbuf', 1);
   $o_treeview->append_column($col1);

   my $col3 = Gtk2::TreeViewColumn->new_with_attributes ($l_for, $listrenderer,
                                                     list => 3,
						     'index' => 0); # to store $cell->{index}
   my $col4 = Gtk2::TreeViewColumn->new_with_attributes("$l_e_c",
                                                       $croprenderer,
			  			       'active', 4);

   my $col6 = Gtk2::TreeViewColumn->new_with_attributes($l_num,
                                                       $numrenderer,
			  			       value => 6);
       
   my $i = 2; # column number

   foreach ($l_fln, $l_for, $l_e_c, $l_ski, $l_num, $l_bor)
      {
    # ( 'Name', 'Format', 'exact/crop', 'Skin', 'Number', 'Border')
	if($i==3){
			$o_treeview->append_column ($col3);
	}
 	elsif($i==4){$o_treeview->append_column ($col4);}
 	elsif($i==6){$o_treeview->append_column ($col6);}
 	else {
 			my $col2 = Gtk2::TreeViewColumn->new_with_attributes($_,
                                                             $textrenderer,
                                                             'text', $i);
 			$o_treeview->append_column($col2);
	}
	$i++;
   }
        my $col2 = Gtk2::TreeViewColumn->new_with_attributes($l_opt,
                                                            $togrenderer,
							    'active', 8);

	$o_treeview->append_column($col2);

	# empty dummy column
	$col1 = Gtk2::TreeViewColumn->new;
	$o_treeview->append_column($col1);
	
	# hide col 3..7 until fotolab is choosen
 	my @columns = $o_treeview->get_columns;
 	foreach my $i (3 .. 7) {
 		   $columns[$i] -> set_visible(0);
 	}

}

sub cell_edited {
  my ($cell, $path, $new_value, $model) = @_;
  $model -> set($model -> get_iter(Gtk2::TreePath -> new_from_string($path)),
                6 => $new_value);
}

sub order_nb {

my ($notebook, @target_table, $win) = @_;
print "creating order NB\n" if $d;

my $vbox2 = Gtk2::VBox->new (0, 0);

my $o_label = Gtk2::Label->new($l_ord);
$o_label->drag_dest_set('all', ['copy', 'move'], @target_table[0..1]); # no rootwin
# TODO signal_connect label: 	$win->set_title ("order list - Gtk Photo Gallery $version");
 
$notebook->append_page( $vbox2, $o_label );
# notebook->Page 2:$vbox2->($hbox2,($oscwin->$o_treeview))

my $hbox2 = Gtk2::HBox->new;
# $hbox2->set_spacing_default(0);
#$hbox2->set_layout ('start');
$vbox2->pack_start($hbox2, 0, 0, 0);

my $o_pButton = Gtk2::Button->new_from_stock ('gtk-open');
$o_pButton ->set_relief ('none');
$hbox2->pack_start ($o_pButton,0, 0,0);

my $o_sButton = Gtk2::Button->new_from_stock ('gtk-save');
$o_sButton ->set_relief ('none');
$hbox2->pack_start ($o_sButton,0, 0,0);

my $o_NButton = Gtk2::Button->new_from_stock ('gtk-clear');
$o_NButton ->set_relief ('none');
$hbox2->pack_start ($o_NButton,0, 0,0);

my $o_DButton = Gtk2::Button->new_from_stock ('gtk-delete');
$o_DButton ->set_relief ('none');
$hbox2->pack_start ($o_DButton,0, 0,0);

my $o_vsep = Gtk2::VSeparator->new();
$hbox2->pack_start ($o_vsep,0 ,0 ,0);

my $o_model = &o_create_model();
 
my $combo = Gtk2::ComboBox->new_text;
$combo->append_text("$l_chl");
$combo->append_text("Fakelab (see what's possible with this app)");
$combo->append_text("$f_lb1");
$combo->set_active (0);

$hbox2->pack_start ($combo,0, 0,0);

# my $o_OButton = Gtk2::Button->new_with_mnemonic ("$l_odn");
my $o_OButton = Gtk2::Button->new_from_stock ('gtk-execute');
# $o_OButton->set_label("$l_odn");
$o_OButton->set_relief ('none');
$hbox2->pack_start ($o_OButton,0, 0,0);

$o_vsep = Gtk2::VSeparator->new();
$hbox2->pack_start ($o_vsep,0, 0,0);

my $labimg = Gtk2::Image->new();
$hbox2->pack_start ($labimg,0, 0,0);

my $o_treeview = &o_create_treeview($o_model);
my $o_scwin = Gtk2::ScrolledWindow->new;
$o_scwin->set_policy ('automatic', 'automatic');

$vbox2->pack_start($o_scwin, 1, 1, 0);
$o_scwin->add($o_treeview);

$combo->signal_connect(changed => sub{ 

	# my ($tmp, $o_treeview) = @_;
	my $iter = $combo->get_active_iter;
	my $c_model = $combo->get_model;
	my $lab = $c_model->get ($iter, 0);
	if($d){print "lab <$lab> choosen\n"}
	my @columns = $o_treeview->get_columns;
	
	if (($lab eq "$f_lb1") || ($lab eq "$l_chl")) {
		foreach my $i (3 .. 7) {
		   $columns[$i] -> set_visible(0);
		}
	}else{
		foreach my $i (3 .. 7) {
		   $columns[$i] -> set_visible(1);
		}
	}
	if ($lab eq "$f_lb1"){
  	   if(-e $lim1){
	   	print"preparing image <$lim1> dialogue\n" if $d;
	   	# my $img1 = Gtk2::Image->new_from_file("$lim1");
		# print "image is <$img1>\n";
		$labimg->set_from_file ($lim1);
		$labimg->show;
	   }
	}
	else {
		$labimg->hide;
	}
	
});

# signals for the order buttons

$o_NButton->signal_connect(clicked => sub{ $o_model->clear()} );

$o_DButton->signal_connect(clicked => sub{ 
	# delete Button
    my $selection= $o_treeview->get_selection();
    my @path = $selection->get_selected_rows();
    if($d){print "deleting row from $o_model ";
             print "selection <$selection> path <@path>\n";}
    my $iter = $o_model->get_iter (@path);
    $o_model->remove($iter);
    });
    
    $o_pButton ->signal_connect(clicked => sub{
    # open an order file 
    my $filesel = Gtk2::FileSelection->new("$l_onr");
    $filesel->set_modal(1);
    # $win->set_keep_below ();
    # $filesel->set_transient_for ($win);
    my $ok_b = $filesel->ok_button;
    $ok_b->signal_connect(clicked => sub{
      my $filename =$filesel->get_filename;
      $filesel->destroy();
      if($d){print"Filename: <$filename>\n"; }
      # 0, 4, 5, 6, 7, 8, 2
	open (FILE, "<$filename");
	while(<FILE>){
	  my @row = split(/ /, $_);
	  #  Alle Felder oberhalb Nr.6 dieser zufuegen, wg white spaces im Namen!
	  chomp($row[6]);
	  my $i = 6;
	  my $j = $#row;
	  while($j > $i){
	  	$i++;
		my $add = $row[$i];
		chomp($add);
		print"adding <$add> to <$row[6]>\n" if $d;
	  	$row[6] = "$row[6] $add";
	  }
	  my $thb1 = $row[6];
      	  $thb1 =~ s/\/([^\/]+)$/\/thumbnails\/$1/g;
      	  $thb1 = $dataroot.$thb1 ;
	  
     	  my $pixbuf = Gtk2::Gdk::Pixbuf->new_from_file ($thb1);
      	  my $iter = $o_model->append;

	  $o_model->set($iter,
			0 => $row[0],
			1 => $pixbuf,
			2 => $row[6],
			3 => [qw/9x13 10x15 13x18 20x30 30x45 40x60 50x75/],
			4 => $row[1], 
			5 => $row[2],
			6 => $row[3],
			7 => $row[4],
			8 => $row[5] );
	  
	}	
	close(FILE);
     });
     my $ca_b = $filesel->  cancel_button;
     $ca_b->signal_connect(clicked => sub{
       $filesel->destroy();
      });
    
     $filesel->show_all();
     });   
         
$o_OButton->signal_connect(clicked => sub{

	# start the order 
      my @or_list;
      my $iter = $o_model->get_iter_first();
      #if($iter){$$win->set_sensitive (0)}
      if($iter){$o_OButton->set_sensitive(0)}
      else{return}; # order list is empty
#      	open(RETA, "| restrans.pl");
    # storing the treemodels data to an array
      do{
        my @row = $o_model->get($iter, 0, 4, 5, 6, 7, 8, 2);
	push(@or_list, [@row]);
	if($d){print "iter is <$iter> ";
		print "row <@row>";
		print "or_list <@or_list>\n";}
      } while ($iter = $o_model->iter_next($iter));

    # forking and running the resizing and transfer in an own prozess
    
      	if($d){print "forking order\n"}
	my $iter1 = $combo->get_active_iter;
	my $c_model = $combo->get_model;
	my $lab = $c_model->get ($iter1, 0);
	
	my $o_win = Gtk2::Window->new;
	$o_win->set_title ("$l_tit $l_ord");
	$o_win->set_resizable (1);
	$o_win->set_default_size (400, 300);
	
	my $o_vbox = Gtk2::VBox->new (0, 0);
	$o_win->add ($o_vbox);

		my $dialog1 = Gtk2::Dialog->new ("$l_tit",
			$win,
			[qw/modal destroy-with-parent/],
			'gtk-ok',
			'ok');
	#my ($ltx);
	#if($lab eq $f_lb1){$ltx = $l_ihg } else {$ltx = "error, no lab specified\n"}

	my $o_txt_body = Gtk2::TextView->new;
	$o_txt_body->set_editable(0);
	$o_txt_body->set_cursor_visible (0);
	#$o_txt_body->set_wrap_mode ('word');
	
	my $o_twin = Gtk2::ScrolledWindow->new();
	$o_twin->set_policy ('automatic', 'automatic');
	$o_twin->add_with_viewport($o_txt_body);
	# my $label1 = Gtk2::Label->new("\n$ltx\n");
	$o_vbox->pack_start ($o_twin, 1, 1, 0);
	#$dialog1->vbox->pack_start ($label1, 0, 0, 0);
	$o_win->set_position('GTK_WIN_POS_CENTER');
	$o_win->set_keep_above (1);
	my $buffer = $o_txt_body->get_buffer;
	$buffer->set_text("$l_ihg\n");

	my $bbox = Gtk2::HButtonBox->new;
	$bbox->set_layout('end');
	
 	my $cbutton = Gtk2::Button->new_from_stock('gtk-cancel');
	$cbutton->signal_connect( 'clicked' => sub { $o_win->destroy; 1;});
# # 	$cbutton->signal_connect( 'clicked' => sub { 
# # 			$o_win->destroy;
# # 			} );
 	$bbox->add($cbutton);
	$o_vbox->pack_start ($bbox, 0, 0, 0);
		
	my $obutton = Gtk2::Button->new_from_stock('gtk-ok');
	$obutton->signal_connect( 'clicked' => sub {
			 $o_OButton->set_sensitive (1);
			 $o_win->destroy;
			 } );
	$bbox->add($obutton);
	
	print "\$lab: <$lab> \$l_chl: <$l_chl>\n" if $d;
	if($lab eq  $l_chl){
		$buffer->set_text("$l_err $l_e4\n");
		$cbutton->set_sensitive (0);
		$o_win->show_all;

	}else{
	
	$obutton->set_sensitive (0);
	if (my $pid = open(CHILD, "-|")) {
		print "parent pid: <$$>\npid: <$pid>\n" if $d;
		my $id = Glib::IO->add_watch(fileno(\*CHILD), 'in', \&gui_pipe, [$buffer, $o_OButton, $obutton, $cbutton]);
		$o_win->signal_connect (destroy => sub {
			#print "calceled with <@_>\n" if $d;
			my ($b, $id) = @_;
			print "remove id: <$id>\n" if $d;
			kill("KILL",$pid);
			$o_OButton->set_sensitive (1); 
			Glib::Source->remove($id); 1 }, $id );
		$o_win->show_all;

		 #waitpid($pid,0);
		return;
	} else {
		print "child pid: <$$>\n" if $d;
	    	print "we are the child\n" if $d;
	    	die "cannot fork: $!" unless defined $pid;
	    	STDOUT->autoflush(1);
		if($d){print "exec restrans.pl lab <$lab> or_list <@or_list>\n"};
		require "$lib/restrans.pl";
		print "require: $!\n" if $d;
		restrans($lab, $obutton, \@or_list);
		print "restrans finished\n" if $d;
	    	exit;
	}
	}
#     if (my $pid = fork) {
#     	# we are the parent
# 	# push @childs, $pid; # TODO make new children available in the main loop
#            my $dialog1 = Gtk2::Dialog->new ("$l_tit",
# 				$win,
# 				[qw/modal destroy-with-parent/],
# 				'gtk-ok',
# 	 			'ok');
# 	   my ($ltx);
# 	   if($lab eq $f_lb1){$ltx = $l_ihg } else {$ltx = "error, no lab specified\n"}
# # 	   print"lab image is <$limg>\n";
# #   	   if(-e $limg){
# # 	   	print"preparing image <$limg> for dialogue\n";
# # 	   	my $img1 = Gtk2::Image->new_from_file("$limg");
# # 		print "image is <$img1>\n";
# # 		# $dialog1->vbox->pack_start ($img1, 0, 0, 0);
# # 		$dialog1->vbox->add ($img1);
# # 	   }
# 	   my $label1 = Gtk2::Label->new("\n$ltx\n");
#   	   $dialog1->vbox->pack_start ($label1, 0, 0, 0);
# 	   $dialog1->set_position('GTK_WIN_POS_CENTER');
# #	   if ('ok' ne $dialog->run) { $dialog->destroy; return}
# 	   $label1->show;
# 	   $dialog1->run;
# 	   $dialog1->destroy;
#           return;
# 	
#     } elsif (defined $pid) { # $pid is zero here if defined
#     	if($d){print "exec restrans.pl\n"};
#     	# we are the child
# 	setsid( );
# 	if($d){print "exec restrans.pl lab <$lab> or_list <@or_list>\n"};
# 		
# 		
# 	require "restrans.pl";
# 	restrans($lab, \@or_list);
# 	
# #	kill($pid); # macht X errors
# 	exit; #
# 
#     } elsif ($! =~ /No more process/) {
#         sleep 5;
#         redo FORK;
#     } else {
#         # weird fork error
#         warn "Can't fork: $!\n";
#     } 
}, \$win);

$o_sButton->signal_connect(clicked => sub{ 

	# save the order into a file
	
    my $filesel = Gtk2::FileSelection->new("$l_sor");
    $filesel->set_modal(1);
    # $win->set_keep_below ();
    # $filesel->set_transient_for ($win);
    my $ok_b = $filesel->ok_button;
    $ok_b->signal_connect(clicked => sub{
      my $filename =$filesel->get_filename;
      $filesel->destroy();
      if($d){print"Filename: <$filename>\n"}
      if(-e $filename) {
        if( -W $filename){
         if(-f $filename){
           my $dialog = Gtk2::Dialog->new ("$l_fxt",
				$win,
				[qw/modal destroy-with-parent/],
				'gtk-ok',
				'ok',
				'gtk-cancel',
				'cancel');

  	   my $label = Gtk2::Label->new("\n$l_fxl\n");
  	   $dialog->vbox->pack_start ($label, 0, 0, 0);
	   $dialog->set_position('GTK_WIN_POS_CENTER');
  	   $dialog->show_all;
  	   if ('ok' ne $dialog->run) { $dialog->destroy; return}
  	   $dialog->destroy;		
	}else{
	           my $dialog = Gtk2::Dialog->new ("$l_err",
				$win,
				[qw/modal destroy-with-parent/],
				'gtk-ok',
				'ok');
			  	
	  my $label = Gtk2::Label->new("$l_e1\n");
  	  $dialog->vbox->pack_start ($label, 0, 0, 0);
	  $dialog->set_position('GTK_WIN_POS_CENTER');
  	  $dialog->show_all;
  	  $dialog->run;
  	  $dialog->destroy;	
	  return;
	}
      
      } else {
        my $dialog = Gtk2::Dialog->new ("$l_err",
				$win,
				[qw/modal destroy-with-parent/],
				'gtk-ok',
				'ok');

  	my $label = Gtk2::Label->new("$l_e2\n");
  	$dialog->vbox->pack_start ($label, 0, 0, 0);
	$dialog->set_position('GTK_WIN_POS_CENTER');
  	$dialog->show_all;
  	$dialog->run;
  	$dialog->destroy;
	return;
      }
      }
      open (FILE, ">$filename");
      close (FILE);
      if(-W $filename){
      
      print "writing $filename\n";    
      open (FILE, ">$filename");
      my $iter = $o_model->get_iter_first();
      do{
        my @row = $o_model->get($iter, 0, 4, 5, 6, 7, 8, 2);
	print "iter is <$iter> ";
	print "print row <@row>\n";
	print FILE "@row\n";
      } while ($iter = $o_model->iter_next($iter));
	# store($mo_list, "$filename");
      close(FILE);
      
      } else {
          my $dialog = Gtk2::Dialog->new ("$l_err",
				$win,
				[qw/modal destroy-with-parent/],
				'gtk-ok',
				'ok');

  	my $label = Gtk2::Label->new("$filename $l_e3\n");
  	$dialog->vbox->pack_start ($label, 0, 0, 0);
	$dialog->set_position('GTK_WIN_POS_CENTER');
  	$dialog->show_all;
  	$dialog->run;
  	$dialog->destroy;
	return;    
      
      }
     });  

my $ca_b = $filesel->  cancel_button;
$ca_b->signal_connect(clicked => sub{
      $filesel->destroy();
});
    
    $filesel -> show_all();
 });
      
$o_label->signal_connect(drag_data_received => \&o_label_drag_data_received, $o_model);

}


sub m_label_drag_data_received {
  my ($widget, $context, $x, $y, $data, $info, $time, $m_model) = @_;
  print "m_label_drag_data_received\n";
  if (($data->length >= 0) && ($data->format == 8))
    {
      my @pictures = @sel_pic; 
      my $tmp;
      if($d){print"\$tmp is <$tmp> \n\@pictures is <@pictures>\n pictures[0]is $pictures[0]\nData is <".$data->data.">\n"}
      foreach my $pic (@pictures){  
      		$pic =~ s/(\/+)/\//g;
		if ($d) {printf ("Received \"%s\" in label\n", $pic);}
		if ($d) {print "\n\$m_model is $m_model\n"}

		my $thb1 = $pic;
      		$thb1 =~ s/\/([^\/]+)$/\/thumbnails\/$1/g;
      		$thb1 = $dataroot.$thb1 ;
      		my $pixbuf = Gtk2::Gdk::Pixbuf->new_from_file ($thb1);
      		my $iter = $m_model->append;
	
		my $txfile = $pic;
		$txfile =~ s/\/([^\/]+)$/\/descriptions\/$1/g;
		$txfile = "$dataroot$txfile\.txt";
		my @desc;
		if(open(TXT, "$txfile")){
		  @desc = <TXT>;
		  close(TXT);
		}
		print "got text <@desc> from file <$txfile>\n";
		my $desc = join(' ', @desc);
		chomp($desc);
# 		$desc =~ s/
# //g; # NON-PRINTABLE CHARACTER!!             DO NOT EDIT !
		$m_model->set($iter,
			0 => $pixbuf,
			1 => $pic,
			2 => $desc);
			
		$context->finish (1, 0, $time);
	}
      		return;
    	}

  $context->finish (0, 0, $time);
}

sub gui_pipe {
	my ($b, $e, $tmp) = @_;
	my @tmp = @$tmp;
	my $buffer  = $tmp[0];
	my $o_OButton = $tmp[1]; # not really necessary
	my $obutton = $tmp[2];
	my $cbutton = $tmp[3];
	my $line = <CHILD>;
	chomp($line);
	_utf8_on($line);
	print "Buffer: <$buffer>\n" if $d;
	print "Parent Pid $$ just read this: `$line'\n" if $d;
	my $text = $buffer->get_text($buffer->get_start_iter, $buffer->get_end_iter, 1);
	chomp($text);
	my $search = 'INFO ';
	if($line =~ s/^$search//g){
		_utf8_off($line);
		$buffer->set_text("$text\n$line");
		Gtk2->main_iteration while Gtk2->events_pending;
	}elsif($line eq "pipe: set ok-button sensitive"){
		$obutton->set_sensitive (1);
		$cbutton->set_sensitive (0);
	}
	
  	if(($line eq "upload done")|| ($line eq '0')){
   		print "close the child and return\n" if $d;
      		close(CHILD); 
  		# $o_OButton->set_sensitive (1);
		$obutton->set_sensitive (1);
		$obutton->grab_focus;
		$cbutton->set_sensitive (0);
		return 0; # return false to uninstall add_watch
  	}
	1;
}

1;